//#include "stdafx.h"      // this is for Visual Studio debugging...
//#include <iostream.h>
//#include <string.h>
//#include <stdlib.h>

//  Copyright (c) 2000 Jan Christian Kaldestad & Hallstein Lohne
//	    USAGE: checkService <ip> <port> <showall/shownone> <services> ... 
//      REQUIRED "../etc/ntpasswd" this file contain password!

#include "util.h"

/*//Globals:
const short SERV_SERVICE_DOES_NOT_EXIST  = 1;
const short SERV_SERVICE_NOT_ACTIVE      = 2;
const short SERV_SERVICE_REQUEST_TIMEOUT = 3;
const short SERV_CHECK_ERROR     = 4;
const short SERV_PAUSED  = 5;
const short SERV_RUNNING = 6;  // Which is quite okay ;-)
const short STATE_OK		=	0; //which is even better ;))
const short STATE_WARNING	=	1;
const short STATE_CRITICAL	=	2;
const short STATE_UNKNOWN   =  -1;
const int MAX_PASSWD_LEN = 400;
const int SRV_CHECK_QUERY = 4;
*/

int showUsage();

//Entry point
int main(int argc, char **argv)
{	
	
     SA_IN 			servaddr;      
	
    bool showWorking = false;
	int g=0;
	int numberOfServices = 0;
	int toReturn=0;
    char **lplpRecList  = new char*[4];
	char **lplpRetCodes = new char*[4];
	char output[800]; // output should not exceed 80 characters!
	
    int 			sockfd, n, i;
    int             index=0, i2=0, nameLen=0; // used in string searching
    int             max_sname_length=100;
    char	     ** lplpServices;
    
    char 			obuf[10000];
    char 			*buffer;
    
    char			ip[15];
    int 			nBytes=0;
    char 			passwd[MAX_PASSWD_LEN];
    int  			passwdLen;
    int 			err;   
    int 			port;   
    if (argc < 5) 
		return showUsage();
/*    //DEBUG: tests the command line by printing it
    cout << "\nArgc=" << argc << "  Full command line:" << endl;
    for (i=1; i<argc; i++)
    {
    cout << "v"<< i << "=" << argv[i]
         << " ";   
    }
    cout << endl;

*/
	numberOfServices = argc-4;
	//cout << "numberofservs=" << numberOfServices << endl;

    //initialize the table
    lplpServices = new char*[numberOfServices];
    lplpRecList  = new char*[numberOfServices];
	lplpRetCodes = new char*[numberOfServices];

    //copying from argv into lplpServices
    for (i=0; i<numberOfServices; i++)
    {
       lplpServices[i] = new char [max_sname_length];
       lplpServices[i] = argv[i+4];
    }

/*  //prints out what we have found in lplpServices
    for (i=0; i<argc-4; i++)
    {
    cout << "\nlplpServices["<< i << "]=" << lplpServices[i]
         << " ";
    }
    cout << endl;
*/
 

    strcpy(ip, argv[1]);
    port = atoi(argv[2]);
	if ( strcmp("showall", argv[3]) == 0) 
		showWorking = true;
	else 
	if ( strcmp("showfail", argv[3]) == 0) 
		showWorking = false;
	else
		return showUsage();

	
    // Get password from file
   if( ChkPasswd(passwd, passwdLen) == STATE_CRITICAL )
   {
	cout << "Error opening passwdfile." << endl;
  	return STATE_CRITICAL;	   
   }
           
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET;
    servaddr.sin_port = htons(port);
    inet_pton(AF_INET, ip, &servaddr.sin_addr);
    
    // Initialisering av server-adressen
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family		 = AF_INET;
    servaddr.sin_port		 = htons(port);
		
    err = inet_aton(ip, &servaddr.sin_addr);
	
    if(err == 0)
    {
      cout << "Invalid IP address" << endl;
      return STATE_CRITICAL;
    }	

    // create tcp-socket and open connection
    sockfd = socket(AF_INET, SOCK_STREAM, 0);
    err = connect(sockfd, (SA*) &servaddr, sizeof(servaddr));

    if(err<0)
    {		    	
    	cout << strerror(errno) << endl;     
	return STATE_CRITICAL;
    }
    int j;
    j  = sprintf( obuf, "id=%d;", SRV_CHECK_QUERY);
    j += sprintf( obuf+j, "key=%s\n;", passwd);   
 
   //insert from our command-string
   for (i=0; i<numberOfServices; i++)
   {
     j += sprintf( obuf+j, lplpServices[i] );  
     j += sprintf( obuf+j, ";");
   }
   j += sprintf( obuf+j, ";;"); //sprintf the close-session-string ";;"


  

  if(!Send( sockfd, obuf))
   {
    cout << "ERROR: Send()" << endl;
    return STATE_CRITICAL;
   }



   cout << "\nSENT:\n" << obuf << endl;


   buffer = Receive( sockfd );
   //buffer = "numBytes=159;Netsaint Service=6;Fiskebolleservice=6;Alsok stop=3;;";
   //buffer = "numBytes=159;Netsaint Service=6;;";
   // end connection
   shutdown(sockfd, 2);


   cout << "\nRECV:" << buffer << "\n" << endl;


   lplpRecList = new char*[numberOfServices];
   i=0;
   g = sprintf(output, "");
   i=0;
   while( index < strlen(buffer) )
	{

		while( buffer[index] != ';' && index < strlen(buffer))
		index++;

		if( buffer[index+1] == ';' ) // end of string
			break;		

		i2 = ++index;    // i2 contains the next ';'
	
		while( buffer[i2] != ';' && i2 < strlen(buffer))
			i2++;
		nameLen = i2-index+1-3;
		lplpRecList[i]  = new char [ nameLen];
		lplpRetCodes[i] = new char[ 1 ];

		strncpy( lplpRecList[i], &buffer[index], nameLen);
		strncpy( lplpRetCodes[i], &buffer[index]+nameLen+1,1); //gets returncode
		strncpy( lplpRecList[i]+nameLen,"\0",1); // sets end
		strncpy( lplpRetCodes[i]+1, "\0",1);

		//checks ReturnCodes and provide output information
		if (atoi(lplpRetCodes[i]) == SERV_SERVICE_DOES_NOT_EXIST)
		{
			g += sprintf(output + g, "NotExist:%s ", lplpRecList[i] );
		    if (toReturn < STATE_WARNING)
				toReturn = STATE_WARNING;
		}
		if (atoi(lplpRetCodes[i]) == SERV_SERVICE_NOT_ACTIVE)
		{
			g += sprintf(output + g, "NotActive:%s ", lplpRecList[i] );
		    if (toReturn < STATE_WARNING)
				toReturn = STATE_WARNING;
		}
		if (atoi(lplpRetCodes[i]) == SERV_SERVICE_REQUEST_TIMEOUT)
		{
			g += sprintf(output + g, "Timeout:%s ", lplpRecList[i] );
		    if (toReturn < STATE_CRITICAL)
				toReturn = STATE_CRITICAL;
		}
		if (atoi(lplpRetCodes[i]) == SERV_CHECK_ERROR)
		{
			g += sprintf(output + g, "CheckError:%s ", lplpRecList[i] );
		    if (toReturn < STATE_CRITICAL)
				toReturn = STATE_CRITICAL;
		}
		if (atoi(lplpRetCodes[i]) == SERV_PAUSED)
		{
			g += sprintf(output + g, "Paused:%s ", lplpRecList[i] );
		    if (toReturn < STATE_WARNING)
				toReturn = STATE_WARNING;
		}
		if (atoi(lplpRetCodes[i]) == SERV_RUNNING)
		{
			if (showWorking)
				g += sprintf(output + g, "OK:%s ", lplpRecList[i] );
		    if (toReturn < STATE_OK)
				toReturn = STATE_OK;
		}
/*
		cout << "lplpRecList" << i << "=" << lplpRecList[i] 
		     << "\tRet" << i << "=" << lplpRetCodes[i]
			<< endl;
*/
		
		i++;
	}


	//prints the one-and-only output
	if (!showWorking)
		if (strlen(output) < 3)
		cout << "All OK";
	cout << output <<endl;
	
/*     //DEBUG:
      cout << "Return=" << toReturn << endl;
*/
	return toReturn;
}

int showUsage()
{
     cout << "  Check NT Service by Jan Christian Kaldestad and Hallstein Lohne\nUsage:\n"
      << "CheckService <ip> <port> <showall/showfail> <Servicename1> [Servicename2]\n"
      << "         ... [\"Service name3\"] [Servicename4] ..." << endl
	  << "E.g.:\n"
	  << "checkService 10.0.0.1 5415 showfail \"NetSaint Service\" Messenger \"Fax Service\" "
      << "\nReply from NTserver(WARNING): \"NotActive:Messenger NotActive:Fax Service\""
      << "\nThis will display only failed services on destination NTserver."
	  << "\n    showall - services which do not fail will also be shown.\n"
      << "    showfail - only services which are not running will be shown.\n"
      << "(NetSaint can only display about 125 characters, so be sure what to monitor.)\n" 
      << "Win32 returncodes which checkService monitors:\n"
      << "SERVICE RESPOND         - NETSAINT RESPOND\n"
      << "Running                 - Returns OK (0)\n"
      << "Does not exit           - Returns WARNING (1)\n"
      << "Is paused               - Returns WARNING (1)\n"
      << "Has not been started    - Returns WARNING (1)\n"
      << "Timout on request       - Returns CRITICAL (2)\n"
      << "Check error.            - Returns CRITICAL (2)\n"
      << endl;
      return STATE_UNKNOWN;
}

