#include "eventlog.h"

#define EVENTLOG_QUERY 11

int main(int argc, char **argv)
{	
    int 			sockfd, n;    
    char 			obuf[BUF_SIZE];
    char 			*buffer;
    char			ip[15];   
    char			url[500];
    int 			nBytes=0;
    char 			passwd[MAX_PASSWD_LEN];
    int  			passwdLen;
    SA_IN 			servaddr;
    int 			servPort;    
    int 			err;
    char 			interval=0;		// tidsrom i minutter       
    struct tm 		time; 
    int				status;    
    int 			port;
	int 			period;
	int				logSize;
	bool 			applog;
	bool 			syslog;
	bool 			seclog;
    EventLogLimits	limits;    
    
    limits.wAudF = limits.eAudF = limits.wAudS = limits.eAudS = limits.wErr = limits.eErr = 0;
    limits.wWarn = limits.eWarn = limits.wInf = limits.eInf = 0;
	
    err = ReadConfigData( url, logSize, argv[1], ip, port, period, applog, syslog, seclog, &limits);  	
      
    if(err!=STATE_OK)
    	return err;
    
   
    // Hent passord fra passordfilen
   if( ChkPasswd(passwd, passwdLen) == STATE_CRITICAL )    	
    	return STATE_CRITICAL; // Noen andre enn NetSaint-brukeren forsker  pne passordfilen	
	
    //cout << "Password: " << &obuf[1] << endl;   
           
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family = AF_INET;
    servaddr.sin_port = htons(port);
    inet_pton(AF_INET, ip, &servaddr.sin_addr);
    
    // Initialisering av server-adressen
	memset(&servaddr, 0, sizeof(servaddr));
	servaddr.sin_family		 = AF_INET;
	servaddr.sin_port		 = htons(port);
		
	err = inet_aton(ip, &servaddr.sin_addr);
	
	if(err == 0) {
		cout << "Invalid IP adress" << endl;
		return STATE_CRITICAL;
	}	

	// create tcp-socket
    sockfd = socket(AF_INET, SOCK_STREAM, 0);
    
    // open connection
    err = connect(sockfd, (SA*) &servaddr, sizeof(servaddr));
    
    if(err<0)
    {		    	
    	cout << strerror(errno) << endl;     
		return STATE_CRITICAL;
	}    
	
	int j;
	
    j  = sprintf( obuf, "id=%d;", EVENTLOG_QUERY);
    j += sprintf( obuf+j, "key=%s\n;", passwd);    
    j += sprintf( obuf+j, "per=%d;", period);
    j += sprintf( obuf+j, "app=%d;", applog);
    j += sprintf( obuf+j, "sys=%d;", syslog);
    j += sprintf( obuf+j, "sec=%d;", seclog);
    j += sprintf( obuf+j, "wAudF=%d;", limits.wAudF);
    j += sprintf( obuf+j, "eAudF=%d;", limits.eAudF);
    j += sprintf( obuf+j, "wAudS=%d;", limits.wAudS);
    j += sprintf( obuf+j, "eAudS=%d;", limits.eAudS);
    j += sprintf( obuf+j, "wErr=%d;", limits.wErr);
    j += sprintf( obuf+j, "eErr=%d;", limits.eErr);
    j += sprintf( obuf+j, "wWarn=%d;", limits.wWarn);
    j += sprintf( obuf+j, "eWarn=%d;", limits.eWarn);
    j += sprintf( obuf+j, "wInf=%d;", limits.wInf);
    j += sprintf( obuf+j, "eInf=%d\n\0", limits.eInf);   
   
    Send(sockfd, obuf);    
    
    buffer = Receive(sockfd);
    
   // cout << buffer << endl;
    
    err = CheckState(buffer); 
   	
   	if(err == STATE_OK)
   	{
   		cout << "Status: OK" << endl;
    	return STATE_OK;
    }
    
    if(err == STATE_UNKNOWN) 
    {    	
   		cout << "Internal error" << endl;
    	return STATE_UNKNOWN;
    }   
    
	GenerateHtml(buffer, period, logSize);
	delete buffer;
	cout << "more info <A HREF=\"" << url << "\">" << "here" << "</A>" << endl;	
	
	return err;
}

int GenerateHtml(char *buffer, int period, int maxSize) 
{		
	const char  *dir = "../share/";
	
	char* oldName = new char[strlen(dir)+strlen(HTMLFILE)+1];
	char* newName = new char[strlen(dir)+strlen("tmp")+1];	
	
	maxSize = maxSize*1024;	
	
    strcpy(oldName, dir);
    strcat(oldName, HTMLFILE);    
    
   // cout << oldName << endl;
	ifstream oldFile(oldName);
	
	
	strcpy(newName, dir);
    strcat(newName, "tmp");
	
	//cout << newName << endl;
	ofstream newFile(newName);
	
	int 	index=0;
	int		col=0;
	int 	status=STATE_WARNING;
	bool 	stop=false;
	
	// write some html code
	
	newFile << "<html>" << endl;
	newFile << "<head>" << endl;
	newFile << "<title>eventlog messages</title>" << endl;	
	newFile << "</head>" << endl;
	newFile << "<body bgcolor=\"#FFFFFF\">" << endl;
	newFile << "<h1>Eventlog messages</h1>" << endl;	
	newFile << "<pre>" << endl;		
	newFile << "<b>******** ";		
	
	WriteDateAndTime(&newFile);	
	
	newFile << " ********</b>" << endl;		
	
	while( index < strlen(buffer) && !stop) 
	{		
		if( strncmp(&buffer[index], "cname=", 6) == 0 )
    	{
    		index += 6;
    		//cout << "Computer:      "; 
    		newFile << "Computer:      "; 
    		while(buffer[index]!=';') {
    		 	//cout << buffer[index];
    		 	newFile << buffer[index++];
    		 }
    		 	
    		//cout << "\nPeriod:        " << period << " minutes" << endl;   	
    		newFile << "\nPeriod:        " << period << " minutes" << endl;
    	}
    	
    	if( strncmp(&buffer[index], "stat=", 5) == 0 )
    	{
    		index += 5;
    		//cout << "Status:        ";
    		newFile << "Status:        ";
    		while(buffer[index]!=';') {
    		 	//cout << buffer[index];
    		 	newFile << buffer[index++];
    		 }
    		 	
    		//cout << endl << endl;
    		newFile << endl << endl;   
    	}
    	
    	if( strncmp(&buffer[index], "src=", 4) == 0 )
    	{
    		index += 4;
    		//cout << "Source:        "; 
    		newFile << "Source:        "; 
    		while(buffer[index]!=';') {
    		 	//cout << buffer[index];
    		 	newFile << buffer[index++];
    		}
    		
    		//cout << endl;
    		newFile << endl;
    	}
    	
    	if( strncmp(&buffer[index], "id=", 3) == 0 )
    	{
    		index += 3;
    		//cout << "Event id:      ";
    		newFile << "Event id:      ";
    		while(buffer[index]!=';') {
    		 	//cout << buffer[index];
    		 	newFile << buffer[index++];
    		}
    		//cout << endl;
    		newFile << endl;    
    	}    	
    	
    	if( strncmp(&buffer[index], "type=", 5) == 0 )
    	{
    		index += 5;
    		//cout << "Event type:    ";
    		newFile << "Event type:    ";
    		
    		switch(atoi(&buffer[index]))
    		{
    			case EVENTLOG_ERROR_TYPE:    				
    		 		//cout << "error";
    		 		newFile << "error";
    		 		break;
    		 	case EVENTLOG_WARNING_TYPE:
    		 		//cout << "warning";
    		 		newFile << "warning";
    		 		break;
    		 	case EVENTLOG_INFORMATION_TYPE:
    		 		//cout << "information";
    		 		newFile << "information";
    		 		break;
    		 	case EVENTLOG_AUDIT_SUCCESS:
    		 		//cout << "audit success" << endl;
    		 		newFile << "audit success" << endl;
    		 		break;
    		 	case EVENTLOG_AUDIT_FAILURE:
    		 		//cout << "audit failure" << endl;
    		 		newFile << "audit failure" << endl;
    		 }
    		 
    		 //cout << endl;
    		 newFile << endl;
    	}
    	
    	if( strncmp(&buffer[index], "cnt=", 4) == 0 )
    	{
    		index += 4;
    		//cout << "Message count: ";
    		newFile << "Message count: ";
    		while(buffer[index]!=';') {
    		 	//cout << buffer[index];
    		 	newFile << buffer[index++];
    		}
    		//cout << endl;
    		newFile << endl;   
    	}    	
    	
    	/*if( strncmp(&buffer[index], "stat=", 5) == 0 )
    	{
    		index += 5;
    		cout << "Status:        ";
    		newFile << "Status:        ";
    		if(buffer[index]=='e') {
    		 	cout << "error";
    		 	newFile << "error";
    		 	status = STATE_CRITICAL;
    		 }
    		 else {
    		 	cout << "warning";
    		 	newFile << "warning";
    		 }
    		 	
    		cout << endl;
    		newFile << endl;   
    	}*/
    	
    	if( strncmp(&buffer[index], "msg=", 4) == 0 )
    	{
    		index += 4;
    		col=0;
    		//cout << "\n\nMessage:\n";
    		newFile << "Message:       ";
    		
    		while( strncmp(&buffer[index], ";src=",5)!=0 ) 
    		{
    		 	//cout << buffer[index];
    		 	if(col>80 && buffer[index] == ' ') 
    		 	{
    		 		newFile << endl << "              ";
    		 		//cout    << endl; 
    		 		col=0;
    		 	}    		 	
    		 	newFile << buffer[index++]; 
    		 	col++;
    		 	
    		 	if( strncmp(&buffer[index], ";;",2)==0)
    		 	{
    		 		//cout << endl;
    		 		stop=true;
    		 		break;    		 		
    		 	}
    		 }
    		 	
    		//cout << endl;
    		newFile << "\n" << endl;  		
    		
    	}    	
    	
    	index++;    	
	}	
	
	char c;
	bool exist=false;
	
	// check if the eventlog.htm  exist
	
	if( oldFile.get(c) )
		exist=true;
	
	index=0;
	
	if(exist)
	{		
		// skip html-code
		while(oldFile.get(c)) {
			index++;
			if(c=='*')
				break;		
		}
		
		if( index < maxSize )
		{		
			newFile << "<b>*";	
			
			while(oldFile.get(c) && index++ < maxSize)
			{				
				newFile.put(c);	
			}
		}
			
		remove(oldName);	
	}	
	
	
	if(!exist || index>maxSize)		
	{		
		newFile << "</pre>" << endl;
		newFile << "</body>" << endl;
		newFile << "</html>" << endl;		
	}		
	
	// rename the newFile
	rename(newName, oldName);
	
	return status;
}

void WriteDateAndTime(ofstream* stream) 
{
	
	time_t 	calTime;	
	tm	   	t;
	
	time(&calTime);	
	t = *localtime(&calTime);
	
	if(t.tm_mday<10)		
		*stream << "0";	
	
	*stream << t.tm_mday << ".";
	
	if(t.tm_mon+1<10)		
		*stream << "0";	
		
	*stream << t.tm_mon+1 << ".";	
	*stream << t.tm_year + 1900 << " ";
	
	if(t.tm_hour<10)		
		*stream << "0";	
	
	*stream << t.tm_hour << ":";
	
	if(t.tm_min<10)		
		*stream << "0";	
	
	
	*stream << t.tm_min;
}

int ReadConfigData( char			*url,
					int				&logSize,
					char			*cName, 
					char			*ip, 
					int				&port,
					int 			&period, 
					bool 			&applog,
					bool 			&syslog,
					bool 			&seclog,
					EventLogLimits* lim)
{
	ifstream 	configFile(CONFIGFILE);
	bool 		exist=false;
	char		c;
	int			nBytes=0;
	int			lineNo=1;	
	const int 	maxLen = 500;		
	char		buffer[maxLen+1];	
	char		computerName[256];
	int 		index=0;
	bool 		found=false;
	
	// check if the eventlog.htm  exist	
	if( !configFile.get(c) ) {
		cout << "Cannot find config file" << endl;
		return STATE_CRITICAL;
	}	
	
	// read logfile url
	if( FindLine(&configFile, "url=", buffer, lineNo) ) {
		
		index=4;
		
		while( buffer[index] == ' ' || buffer[index] == '\t' && index<maxLen )
			index++;
		
		strcpy(url, &buffer[index]);		
		//cout << url << endl;
	}
	else {
		cout << "Error: url not found in config file" << endl;
		return STATE_CRITICAL;
	}
	
	// read maximum logsize
	if( FindLine(&configFile, "logsize=", buffer, lineNo) ) {
		
		index=8;
		char	tmp[20];
		
		while( buffer[index] == ' ' || buffer[index] == '\t' && index<maxLen )
			index++;
		
		strcpy(tmp, &buffer[index]);		
		logSize = atoi(tmp);		
		
		if(logSize<0)
		{			
			cout << "Error in line " << lineNo << ": " << buffer << endl;
			return STATE_CRITICAL;			
		}		
	}
	else {
		cout << "Error: logsize not found in config file" << endl;
		return STATE_CRITICAL;
	}	
	
	if(!ReadComputerName(&configFile, buffer, cName, lineNo) )
		return STATE_CRITICAL;	
	
	if(!ReadIPadr(&configFile, buffer, cName, ip, lineNo))
		return STATE_CRITICAL;
		
	if(!ReadPort(&configFile, buffer, cName, port, lineNo))
		return STATE_CRITICAL;		
	
	if(!ReadPeriod(&configFile, buffer, cName, period, lineNo))
		return STATE_CRITICAL;
	
	if(!ReadLogValues(&configFile, buffer, lineNo, applog, syslog, seclog))
		return STATE_CRITICAL;	
	
	if(!ReadLimits(&configFile, buffer, lim, lineNo))
		return STATE_CRITICAL;	
		
	return STATE_OK;
}


bool FindLine(ifstream* file, char* str, char* buffer, int &lineNo) {
	
	const int 	maxLen=500;
	//bool		found=false;
	int			index=0;
		
	while(file->getline(buffer, maxLen) /*&& !found */)	
	{
		lineNo++;
		// skip lines starting with '#', blanks, tabs and newlines		
		if(buffer[0]!='#' && buffer[0]!=' ' && buffer[0]!='\t' && buffer[0]!='\x0' && buffer[0]!='\x0D')
		{			
			//printf("%x", buffer[0]);
			//cout << buffer << endl;
			if( buffer[0]=='\0')	// UNIX-format
				file->getline(buffer, maxLen);
				
			//cout << buffer << endl;
			if(strncmp(buffer, str, strlen(str)) == 0)
			{				
				while( buffer[index] != '\r' && index<256 )
					index++;
				
				buffer[index]='\0';										
							
				return true;
			}
			else
				return false;
		}		
	}	
	return false;
}

bool ReadLimits2(ifstream* file, char* buffer, char* str, int &warn, int &err, int &lineNo)
{
	int index=0;
	
	if( FindLine(file, str, buffer, lineNo) ) {
		warn = atoi(&buffer[strlen(str)]);		
		
		//cout << warn << endl;
		
		if(warn < 0) {
			cout << "Error in line " << lineNo << ": " << buffer << endl;
			return false;
		}
		
		if(warn > 0) {
			index = strlen(str);
			
			while(buffer[index]!='/' && index << sizeof(*buffer) )
				index++;								
			
			err = atoi(&buffer[index+1]);
			
			if(err <= warn) {
				cout << "Error in line " << lineNo << ": " << buffer << endl;
				return false;
			}
						
			//cout << err << endl;
		}
		else
			err = 0;
					
		return true;
	}
	
	cout << "Error: '" << str << "' is not set in config file" << endl;		
		
	return false;
}

bool ReadLimits(ifstream* file, char* buffer, EventLogLimits* lim, int &lineNo)
{	
	// find the line starting with "auditFailure="
	if( !ReadLimits2(file, buffer, "auditFailure=", lim->wAudF, lim->eAudF, lineNo) )
		return false;
	
	// find the line starting with "auditSuccess="
	if( !ReadLimits2(file, buffer, "auditSuccess=", lim->wAudS, lim->eAudS, lineNo) )
		return false;
		
	// find the line starting with "error="
	if( !ReadLimits2(file, buffer, "error=", lim->wErr, lim->eErr, lineNo) )
		return false;
		
	// find the line starting with "warning="
	if( !ReadLimits2(file, buffer, "warning=", lim->wWarn, lim->eWarn, lineNo) )
		return false;
		
	// find the line starting with "information="
	if( !ReadLimits2(file, buffer, "information=", lim->wInf, lim->eInf, lineNo) )
		return false;
	
	return true;
}

bool ReadComputerName(ifstream* file, char* buffer, char*  cName, int &lineNo)
{
	bool 	found=false;
	int 	index=0;
	char	computerName[256];
	
	while(file->getline(buffer, 500) && !found )
	{	
		index=0;
		
		// skip lines starting with # blanks and newlines
		if( buffer[0]==' ' || buffer[0]=='#' || buffer[0]=='\r' || buffer[0]=='\t')
		{			
			lineNo++;
			continue;
		}
					
		if(buffer[0]=='[')
		{
			while( buffer[index] != ']' && index<256 )
				computerName[index]=buffer[++index];
			
			computerName[index-1]='\0';
				
			if(strcmp(computerName, cName) == 0) {
				found=true;
				break;
			}
		}
		
		lineNo++;	
	}
	
	if(!found) {
		cout << "Error: " << cName << " not found in config file" << endl;
		return false;
	}
	
	//cout << computerName << " " << lineNo << endl;
	return true;
}

bool ReadLogValues(ifstream* file, char* buffer, int &lineNo, bool& applog, bool& syslog, bool& seclog)
{
	// find the line starting with "applicationlog="
	if( FindLine(file, "applicationlog=", buffer, lineNo) ) {
		applog = atoi(&buffer[strlen("applicationlog=")]);		
		//cout << applog << endl;
	}
	else {
		cout << "Error: 'applicationlog=' is not set in config file" << endl;		
		return false;
	}
	
	// find the line starting with "systemlog="
	if( FindLine(file, "systemlog=", buffer, lineNo) ) {
		syslog = atoi(&buffer[strlen("systemlog=")]);	
		//cout << syslog << endl;
	}
	else {
		cout << "Error: 'systemlog=' is not set in config file" << endl;
		return false;
	}
			
	// find the line starting with "securitylog="
	if( FindLine(file, "securitylog=", buffer, lineNo) ) {
		seclog = atoi(&buffer[strlen("securitylog=")]);	
		//cout << seclog << endl;
	}
	else {
		cout << "Error: 'securitylog=' is not set in config file" << endl;		
		return false;
	}
	
	return true;
}

bool ReadIPadr(ifstream* file, char* buffer, char* cName, char* ip, int &lineNo)
{
	if( FindLine(file, "ip=", buffer, lineNo) ) {		
		strcpy(ip, &buffer[3]);
		
		// check ip-adress
		struct sockaddr_in servaddr;	
		if( inet_aton(ip, &servaddr.sin_addr) == 0) {
			cout << "Error in line " << lineNo << ": " << buffer << endl;
			return false;
		}		
		
		//cout << ip << endl;
	}
	else {
		cout << "Error: Could not find ip-adress of " << cName << endl;
		return false;
	}
	
	return true;
}

bool ReadPort(ifstream* file, char* buffer, char* cName, int &port, int &lineNo)
{
	if( FindLine(file, "port=", buffer, lineNo) ) {
		port = atoi(&buffer[5]);
		
		// check port
		if(port<0 || port>65535) {
			cout << "Error in line " << lineNo << ": " << buffer << endl;
			return false;
		}
			
		//cout << port << endl;
	}
	else {
		cout << "Error: Could not find port numner of " << cName << endl;
		return false;
	}
	
	return true;
}

bool ReadPeriod(ifstream* file, char* buffer, char* cName, int &period, int &lineNo)
{
	if( FindLine(file, "period=", buffer, lineNo) ) {
		period = atoi(&buffer[7]);	
		
		if(period<1) {
			cout << "Error in line " << lineNo << ": " << buffer << endl;
			return false;
		}
		//cout << period << endl;
	}
	else {
		cout << "Error: Could not find period of " << cName << endl;
		return false;
	}
	
	return true;
}

int CheckState(char *buffer)
{
	int index=0;
	
	while( strncmp(&buffer[index], "stat=", 5)!=0 && index<strlen(buffer))
    	index++;
    	
    if(index==strlen(buffer))
    	return STATE_UNKNOWN;
    	
    index+=5;
    
    if(strncmp(&buffer[index], "ok", 2)==0)
    	return STATE_OK;
    	   		
    if(strncmp(&buffer[index], "error", 5)==0)
    	return STATE_CRITICAL;    	
    	
    return STATE_WARNING;
}