#ifndef netutilH
#define netutilH

#include <winsock.h>
#include <iostream.h>
#include <stdio.h>
#include <math.h>
#include "err.h"
#include "eventLog.h"
#include "Common.h"
#include "common.h"
#include "checkService.h"

#define	TCPLOG		"tcpErrLog.txt"
#define	SA			struct sockaddr
#define SA_IN		struct sockaddr_in

extern int	servPort;
extern char	*passwd;


//
//  FUNCTION: DWORD WINAPI TCP_Connection( LPVOID pParam )
//
//  PURPOSE: Thread function which listens for TCP connections
//			 and sends reply back to client
//
//  PARAMETERS:
//		not used
//    
//  RETURN VALUE:
//		not used
//
DWORD WINAPI TCP_Connection( LPVOID pParam );


//
//  FUNCTION: bool CheckPasswd(char *ibuf, char *passwd)
//
//  PURPOSE: get the client's password from ibuf, 
//			 and compare it to the real one.
//
//  PARAMETERS:
//		ibuf - buffer received from client
//		passwd - password from passwordfile
//    
//  RETURN VALUE:
//		true - password OK
//		false - wrong password
//
bool CheckPasswd(char *ibuf, char *passwd);


//
//  FUNCTION: int AnalyzeTCPMessage( char *ibuf, 
//									 char *msgBuf, 
//									 DWORD &msgBufSize, 
//									 char *passwd)
//
//  PURPOSE: Read incoming buffer from client, and reply according to
//			 the request type.			 
//
//  PARAMETERS:
//		ibuf - message (request) received from client
//		msgBuf - message (reply) to send back to client
//		msgBufSize - size of msgBuf, contains the size required if
//					 msgBuf is too small
//		passwd - password from passwordfile
//		
//  RETURN VALUE:
//		NOERR - OK, msgBuf ready to be sent back to client
//		ERR_AUTHENTICATION - the password was wrong
//		ERR_BUFFER_TOO_SMALL - msgBuf is too smal
//		ERR_NO_SUCH_MESSAGE - the request is undefined
//
int AnalyzeTCPMessage(char *ibuf, char *msgBuf, DWORD &msgBufSize, char *passwd);


//
//  FUNCTION: bool Send(SOCKET sockfd, char *buffer)
//
//  PURPOSE: Send a message to the client (buffersize doesn't matter).
//
//  PARAMETERS: 
//		sockfd - socket descriptor for the connection
//		buffer - buffer to send
//    
//  RETURN VALUE:
//		true - operation OK
//		false - something went wrong
//
bool Send(SOCKET sockfd, char *buffer);


//
//  FUNCTION: char* Receive(SOCKET sockfd)
//
//  PURPOSE: Receive a message from the client
//
//  PARAMETERS:
//		sockd - socket descriptor for the connection	
//    
//  RETURN VALUE:
//		buffer recieved from client.
//
//	COMMENT:
//		The buffer received should be deleted when you are finished using it
//		since the memory is allocated dynamially inside the function.
//
char* Receive(SOCKET sockfd);

#endif